-- arconst.e
-- Cut-down version of constants.ew for use (by eawpaint) in
-- emergencies, when constants.ew cannot be found anywhere else.

constant


	-- Class Styles
	CS_BYTEALIGNCLIENT = 4096,
	CS_BYTEALIGNWINDOW = 8192,
	CS_KEYCVTWINDOW = 4,
	CS_NOKEYCVT = 256,
	CS_CLASSDC = 64,
	CS_DBLCLKS = 8,
	CS_GLOBALCLASS = 16384,
	CS_HREDRAW = 2,
	CS_NOCLOSE = 512,
	CS_OWNDC = 32,
	CS_PARENTDC = 128,
	CS_SAVEBITS = 2048,
	CS_VREDRAW = 1,

	-- Common Control Styles
	CCS_ADJUSTABLE      = #20,
	CCS_BOTTOM          = #3,
	CCS_NODIVIDER       = #40,
	CCS_NOMOVEY         = #2,
	CCS_NOPARENTALIGN   = #8,
	CCS_NORESIZE        = #4,
	CCS_TOP             = #1,
	ANIMATE_CLASSA      = "SysAnimate32",
	HOTKEY_CLASSA       = "msctls_hotkey32",
	PROGRESS_CLASSA     = "msctls_progress32",
	STATUSCLASSNAMEA    = "msctls_statusbar32",
	TOOLBARCLASSNAMEA   = "ToolbarWindow32",
	TOOLTIPS_CLASSA     = "tooltips_class32",
	TRACKBAR_CLASSA     = "msctls_trackbar32",
	UPDOWN_CLASSA       = "msctls_updown32",
	WC_HEADERA          = "SysHeader32",
	WC_LISTVIEWA        = "SysListView32",
	WC_LISTVIEW         = WC_LISTVIEWA,
	WC_TABCONTROLA      = "SysTabControl32",
	WC_TREEVIEWA        = "SysTreeView32",
	MONTHCAL_CLASS      = "SysMonthCal32",
	REBARCLASSNAME      = "ReBarWindow32",
	ANIMATE_CLASS       = "SysAnimate32",
	DATETIMEPICK_CLASS  = "SysDateTimePick32",
	WC_PAGESCROLLER     = "SysPager",
	WC_NATIVEFONTCTL    = "NativeFontCtl",
	WC_COMBOBOXEX       = "ComboBoxEx32",

	-- Windows Styles
	CW_USEDEFAULT =  #80000000,
	WS_BORDER =  #800000,
	WS_CAPTION =  #C00000,
	WS_CHILD =  #40000000,
	WS_CHILDWINDOW =  #40000000,
	WS_CLIPCHILDREN =  #2000000,
	WS_CLIPSIBLINGS =  #4000000,
	WS_DISABLED =  #8000000,
	WS_DLGFRAME =  #400000,
	WS_GROUP =  #20000,
	WS_HSCROLL =  #100000,
	WS_ICONIC =  #20000000,
	WS_MAXIMIZE =  #1000000,
	WS_MAXIMIZEBOX =  #10000,
	WS_MINIMIZE =  #20000000,
	WS_MINIMIZEBOX =  #20000,
	WS_OVERLAPPED = 0,
	WS_OVERLAPPEDWINDOW =  #CF0000,
	WS_POPUP =  #80000000,
	WS_POPUPWINDOW =  #80880000,
	WS_SIZEBOX =  #40000,
	WS_SYSMENU =  #80000,
	WS_TABSTOP =  #10000,
	WS_THICKFRAME =  #40000,
	WS_TILED = 0,
	WS_TILEDWINDOW =  #CF0000,
	WS_VISIBLE =  #10000000,
	WS_VSCROLL =  #200000,

	-- Extended Windows Styles
	WS_EX_ACCEPTFILES = 16,
	WS_EX_APPWINDOW =  #40000,
	WS_EX_CLIENTEDGE = 512,
	WS_EX_CONTEXTHELP =  #400,
	WS_EX_CONTROLPARENT =  #10000,
	WS_EX_DLGMODALFRAME = 1,
	WS_EX_LEFT = 0,
	WS_EX_LEFTSCROLLBAR =  #4000,
	WS_EX_LTRREADING = 0,
	WS_EX_MDICHILD = 64,
	WS_EX_NOPARENTNOTIFY = 4,
	WS_EX_OVERLAPPEDWINDOW =  #300,
	WS_EX_PALETTEWINDOW =  #188,
	WS_EX_RIGHT =  #1000,
	WS_EX_RIGHTSCROLLBAR = 0,
	WS_EX_RTLREADING =  #2000,
	WS_EX_STATICEDGE =  #20000,
	WS_EX_TOOLWINDOW = 128,
	WS_EX_TOPMOST = 8,
	WS_EX_TRANSPARENT = 32,
	WS_EX_WINDOWEDGE = 256,
	WS_EX_LAYERED         = #00080000,
	WS_EX_NOINHERITLAYOUT = #00100000, -- Disable inheritence of mirroring by children
	WS_EX_LAYOUTRTL       = #00400000, --Right to left mirroring
	WS_EX_NOACTIVATE      = #08000000,

	-- Other Control Styles
	MDIS_ALLCHILDSTYLES = 1,

	ES_AUTOHSCROLL = 128,
	ES_AUTOVSCROLL = 64,
	ES_CENTER = 1,
	ES_LEFT = 0,
	ES_LOWERCASE = 16,
	ES_MULTILINE = 4,
	ES_NOHIDESEL = 256,
	ES_NUMBER =  #2000,
	ES_OEMCONVERT =  #400,
	ES_PASSWORD = 32,
	ES_READONLY =  #800,
	ES_RIGHT = 2,
	ES_UPPERCASE = 8,
	ES_WANTRETURN = 4096,

	CBS_AUTOHSCROLL = 64,
	CBS_DISABLENOSCROLL =  #800,
	CBS_DROPDOWN = 2,
	CBS_DROPDOWNLIST = 3,
	CBS_HASSTRINGS = 512,
	CBS_LOWERCASE =  #4000,
	CBS_NOINTEGRALHEIGHT =  #400,
	CBS_OEMCONVERT = 128,
	CBS_OWNERDRAWFIXED = 16,
	CBS_OWNERDRAWVARIABLE = 32,
	CBS_SIMPLE = 1,
	CBS_SORT = 256,
	CBS_UPPERCASE =  #2000,

	CB_ADDSTRING = 323,
	CB_DELETESTRING = 324,
	CB_DIR = 325,
	CB_FINDSTRING = 332,
	CB_FINDSTRINGEXACT = 344,
	CB_GETCOUNT = 326,
	CB_GETCURSEL = 327,
	CB_GETDROPPEDCONTROLRECT = 338,
	CB_GETDROPPEDSTATE = 343,
	CB_GETDROPPEDWIDTH = 351,
	CB_GETEDITSEL = 320,
	CB_GETEXTENDEDUI = 342,
	CB_GETHORIZONTALEXTENT = 349,
	CB_GETITEMDATA = 336,
	CB_GETITEMHEIGHT = 340,
	CB_GETLBTEXT = 328,
	CB_GETLBTEXTLEN = 329,
	CB_GETLOCALE = 346,
	CB_GETTOPINDEX = 347,
	CB_INITSTORAGE = 353,
	CB_INSERTSTRING = 330,
	CB_LIMITTEXT = 321,
	CB_RESETCONTENT = 331,
	CB_SELECTSTRING = 333,
	CB_SETCURSEL = 334,
	CB_SETDROPPEDWIDTH = 352,
	CB_SETEDITSEL = 322,
	CB_SETEXTENDEDUI = 341,
	CB_SETHORIZONTALEXTENT = 350,
	CB_SETITEMDATA = 337,
	CB_SETITEMHEIGHT = 339,
	CB_SETLOCALE = 345,
	CB_SETTOPINDEX = 348,
	CB_SHOWDROPDOWN = 335,

	CB_ERR = -1,
	CB_ERRSPACE = -2,
	
	CBN_CLOSEUP = 8,
	CBN_DBLCLK = 2,
	CBN_DROPDOWN = 7,
	CBN_EDITCHANGE = 5,
	CBN_EDITUPDATE = 6,
	CBN_ERRSPACE = -1,
	CBN_KILLFOCUS = 4,
	CBN_SELCHANGE = 1,
	CBN_SELENDCANCEL = 10,
	CBN_SELENDOK = 9,
	CBN_SETFOCUS = 3,

	


	LB_ADDFILE = 406,
	LB_ADDSTRING = 384,
	LB_DELETESTRING = 386,
	LB_DIR = 397,
	LB_FINDSTRING = 399,
	LB_FINDSTRINGEXACT = 418,
	LB_GETANCHORINDEX = 413,
	LB_GETCARETINDEX = 415,
	LB_GETCOUNT = 395,
	LB_GETCURSEL = 392,
	LB_GETHORIZONTALEXTENT = 403,
	LB_GETITEMDATA = 409,
	LB_GETITEMHEIGHT = 417,
	LB_GETITEMRECT = 408,
	LB_GETLOCALE = 422,
	LB_GETSEL = 391,
	LB_GETSELCOUNT = 400,
	LB_GETSELITEMS = 401,
	LB_GETTEXT = 393,
	LB_GETTEXTLEN = 394,
	LB_GETTOPINDEX = 398,
	LB_INITSTORAGE = 424,
	LB_INSERTSTRING = 385,
	LB_ITEMFROMPOINT = 425,
	LB_RESETCONTENT = 388,
	LB_SELECTSTRING = 396,
	LB_SELITEMRANGE = 411,
	LB_SELITEMRANGEEX = 387,
	LB_SETANCHORINDEX = 412,
	LB_SETCARETINDEX = 414,
	LB_SETCOLUMNWIDTH = 405,
	LB_SETCOUNT = 423,
	LB_SETCURSEL = 390,
	LB_SETHORIZONTALEXTENT = 404,
	LB_SETITEMDATA = 410,
	LB_SETITEMHEIGHT = 416,
	LB_SETLOCALE = 421,
	LB_SETSEL = 389,
	LB_SETTABSTOPS = 402,
	LB_SETTOPINDEX = 407,

	LB_ERR = -1,
	LB_ERRSPACE = -2,

	LBN_DBLCLK = 2,
	LBN_ERRSPACE = -2,
	LBN_KILLFOCUS = 5,
	LBN_SELCANCEL = 3,
	LBN_SELCHANGE = 1,
	LBN_SETFOCUS = 4,

	LBS_DISABLENOSCROLL = 4096,
	LBS_EXTENDEDSEL =  #800,
	LBS_HASSTRINGS = 64,
	LBS_MULTICOLUMN = 512,
	LBS_MULTIPLESEL = 8,
	LBS_NODATA =  #2000,
	LBS_NOINTEGRALHEIGHT = 256,
	LBS_NOREDRAW = 4,
	LBS_NOSEL =  #4000,
	LBS_NOTIFY = 1,
	LBS_OWNERDRAWFIXED = 16,
	LBS_OWNERDRAWVARIABLE = 32,
	LBS_SORT = 2,
	LBS_STANDARD =  #A00003,
	LBS_USETABSTOPS = 128,
	LBS_WANTKEYBOARDINPUT =  #400,

--PLlv
--	LVS_ICON				=  #0,
	LVS_REPORT				=  #1,
--	LVS_SMALLICON			=  #2,
--	LVS_LIST				=  #3,
--	LVS_TYPEMASK			=  #3,
--	LVS_SINGLESEL			=  #4,
--	LVS_SHOWSELALWAYS		=  #8,
--	LVS_SORTASCENDING		=  #10,
--	LVS_SORTDESCENDING		=  #20,
	LVS_SHAREIMAGELISTS 	=  #40,
--	LVS_NOLABELWRAP 		=  #80,
--	LVS_AUTOARRANGE 		=  #100,
--	LVS_EDITLABELS			=  #200,
--	LVS_OWNERDATA			=  #1000,
--	LVS_NOSCROLL			=  #2000,
--	LVS_TYPESTYLEMASK		=  #FC00,
--	LVS_ALIGNTOP			=  #0,
--	LVS_ALIGNLEFT			=  #800,
--	LVS_ALIGNMASK			=  #C00,
--	LVS_OWNERDRAWFIXED		=  #400,
--	LVS_NOCOLUMNHEADER		=  #4000,
--	LVS_NOSORTHEADER		=  #8000,
--
--
--	LVA_DEFAULT 			= 0,
--	LVA_ALIGNLEFT			= 1,
--	LVA_ALIGNTOP			= 2,
--	LVA_SNAPTOGRID			= 5,
--
--	LVS_EX_GRIDLINES		= 1,
--	LVS_EX_SUBITEMIMAGES	= 2,
--	LVS_EX_CHECKBOXES		= 4,
--	LVS_EX_TRACKSELECT		= 8,
--	LVS_EX_HEADERDRAGDROP	= #10,
--	LVS_EX_FULLROWSELECT	= #20,
--	LVS_EX_ONECLICKACTIVATE = #40,
--	LVS_EX_TWOCLICKACTIVATE = #80,
--	LVS_EX_FLATSB			= #100,
--	LVS_EX_REGIONAL 		= #200,
--	LVS_EX_NFOTIP			= #400,
--	LVS_EX_UNDERLINEHOT 	= #800,
--	LVS_EX_UNDERLINECOLD	= #1000,
--	LVS_EX_MULTIWORKAREAS	= #2000,
--
	LVM_FIRST				=  #1000,
--	LVM_GETBKCOLOR			=  (LVM_FIRST + 0),
--	LVM_SETBKCOLOR			=  (LVM_FIRST + 1),
--	LVM_GETIMAGELIST		=  (LVM_FIRST + 2),
--	LVM_SETIMAGELIST		=  (LVM_FIRST + 3),
	LVM_GETITEMCOUNT		=  (LVM_FIRST + 4),
--	LVM_GETITEMA			=  (LVM_FIRST + 5),
--	LVM_GETITEM 			=  LVM_GETITEMA,
--	LVM_SETITEMA			=  (LVM_FIRST + 6),
--	LVM_SETITEM 			=  LVM_SETITEMA,
	LVM_INSERTITEMA 		=  (LVM_FIRST + 7),
	LVM_INSERTITEM			=  LVM_INSERTITEMA,
--	LVM_DELETEITEM			=  (LVM_FIRST + 8),
	LVM_DELETEALLITEMS		=  (LVM_FIRST + 9),
--	LVM_GETCALLBACKMASK 	=  (LVM_FIRST + 10),
--	LVM_SETCALLBACKMASK 	=  (LVM_FIRST + 11),
--	LVM_GETNEXTITEM 		=  (LVM_FIRST + 12),
--	LVM_FINDITEM			=  (LVM_FIRST + 13),
--	LVM_GETITEMRECT 		=  (LVM_FIRST + 14),
--	LVM_SETITEMPOSITION 	=  (LVM_FIRST + 15),
--	LVM_GETITEMPOSITION 	=  (LVM_FIRST + 16),
--	LVM_GETSTRINGWIDTH		=  (LVM_FIRST + 17),
--	LVM_HITTEST 			=  (LVM_FIRST + 18),
	LVM_ENSUREVISIBLE		=  (LVM_FIRST + 19),
--	LVM_SCROLL				=  (LVM_FIRST + 20),
--	LVM_REDRAWITEMS 		=  (LVM_FIRST + 21),
--	LVM_ARRANGE 			=  (LVM_FIRST + 22),
--	LVM_EDITLABEL			=  (LVM_FIRST + 23),
--	LVM_GETEDITCONTROL		=  (LVM_FIRST + 24),
--	LVM_GETCOLUMN			=  (LVM_FIRST + 25),
	LVM_INSERTCOLUMNA		=  (LVM_FIRST + 27),
	LVM_INSERTCOLUMN		=  LVM_INSERTCOLUMNA,
--	LVM_DELETECOLUMN		=  (LVM_FIRST + 28),
--	LVM_SETCOLUMN			=  4122,
--	LVM_GETCOLUMNWIDTH		=  (LVM_FIRST + 29),
--	LVM_SETCOLUMNWIDTH		=  (LVM_FIRST + 30),
--	LVM_GETHEADER			=  (LVM_FIRST + 31),
--	LVM_CREATEDRAGIMAGE 	=  (LVM_FIRST + 33),
--	LVM_GETVIEWRECT 		=  (LVM_FIRST + 34),
--	LVM_GETTEXTCOLOR		=  (LVM_FIRST + 35),
--	LVM_SETTEXTCOLOR		=  (LVM_FIRST + 36),
--	LVM_GETTEXTBKCOLOR		=  (LVM_FIRST + 37),
--	LVM_SETTEXTBKCOLOR		=  (LVM_FIRST + 38),
--	LVM_GETTOPINDEX 		=  (LVM_FIRST + 39),
--	LVM_GETCOUNTPERPAGE 	=  (LVM_FIRST + 40),
--	LVM_GETORIGIN			=  (LVM_FIRST + 41),
--	LVM_UPDATE				=  (LVM_FIRST + 42),
--	LVM_SETITEMSTATE		=  (LVM_FIRST + 43),
--	LVM_GETITEMSTATE		=  (LVM_FIRST + 44),
	LVM_GETITEMTEXTA		=  (LVM_FIRST + 45),
	LVM_GETITEMTEXT 		=  LVM_GETITEMTEXTA,
	LVM_SETITEMTEXTA		=  (LVM_FIRST + 46),
	LVM_SETITEMTEXT 		=  LVM_SETITEMTEXTA,
	LVM_SETITEMCOUNT		=  (LVM_FIRST + 47),
--	LVM_SORTITEMS			=  (LVM_FIRST + 48),
--	LVM_SETITEMPOSITION32	=  (LVM_FIRST + 49),
--	LVM_GETSELECTEDCOUNT	=  (LVM_FIRST + 50),
--	LVM_GETITEMSPACING		=  (LVM_FIRST + 51),
--	LVM_GETISEARCHSTRINGA	=  (LVM_FIRST + 52),
--	LVM_GETISEARCHSTRING	=  LVM_GETISEARCHSTRINGA,
--	LVM_SETICONSPACING		=  (LVM_FIRST + 53),
--	LVM_SETEXTENDEDLISTVIEWSTYLE =	(LVM_FIRST + 54),
--	LVM_GETEXTENDEDLISTVIEWSTYLE =	(LVM_FIRST + 55),
--	LVM_GETSUBITEMRECT		=  (LVM_FIRST + 56),
--	LVM_SUBITEMHITTEST		=  (LVM_FIRST + 57),
--	LVM_SETCOLUMNORDERARRAY =  (LVM_FIRST + 58),
--	LVM_GETCOLUMNORDERARRAY =  (LVM_FIRST + 59),
--	LVM_SETHOTITEM			=  (LVM_FIRST + 60),
--	LVM_GETHOTITEM			=  (LVM_FIRST + 61),
--	LVM_SETHOTCURSOR		=  (LVM_FIRST + 62),
--	LVM_GETHOTCURSOR		=  (LVM_FIRST + 63),
--	LVM_APPROXIMATEVIEWRECT =  (LVM_FIRST + 64),
--	LV_MAX_WORKAREAS		=  16,
--	LVM_SETWORKAREAS		=  (LVM_FIRST + 65),
--	LVM_GETSELECTIONMARK	=  (LVM_FIRST + 66),
--	LVM_SETSELECTIONMARK	=  (LVM_FIRST + 67),
--	LVM_GETWORKAREAS		=  (LVM_FIRST + 70),
--	LVM_SETHOVERTIME		=  (LVM_FIRST + 71),
--	LVM_GETHOVERTIME		=  (LVM_FIRST + 72),
--	LVM_GETNUMBEROFWORKAREAS=  (LVM_FIRST + 73),
--	LVM_SETTOOLTIPS 		=  (LVM_FIRST + 74),
--	LVM_GETTOOLTIPS 		=  (LVM_FIRST + 78),
--
--	LVSCW_AUTOSIZE				= -1,
--	LVSCW_AUTOSIZE_USEHEADER	= -2,
--
--	LVFINDINFO_flags		= w32allot( Long ),
--	LVFINDINFO_psz			= w32allot( Lpsz ),
--	LVFINDINFO_lParam		= w32allot( Long ),
--	LVFINDINFO_ptX			= w32allot( Long ),
--	LVFINDINFO_ptY			= w32allot( Long ),
--	LVFINDINFO_vkDirection	= w32allot( Long ),
--	SIZEOF_LVFINDINFO		= w32allotted_size(),
--
--	LVFI_PARAM				=  #1,
--	LVFI_STRING 			=  #2,
--	LVFI_PARTIAL			=  #8,
--	LVFI_WRAP				=  #20,
--	LVFI_NEARESTXY			=  #40,
--
--	LVNI_ALL				= 0,
--	LVNI_FOCUSED			= 1,
--	LVNI_SELECTED			= 2,
--	LVNI_CUT				= 4,
--	LVNI_DROPHILITED		= 8,
--
--	LVNI_ABOVE				= #100,
--	LVNI_BELOW				= #200,
--	LVNI_TOLEFT 			= #400,
--	LVNI_TORIGHT			= #800,
--
	LVIF_TEXT				= 1,
--	LVIF_IMAGE				= 2,
--	LVIF_PARAM				= 4,
--	LVIF_STATE				= 8,
--	LVIF_INDENT 			= #10,
--	LVIF_NORECOMPUTE		= #800,
--	LVIF_DI_SETITEM 		= #1000,
--
	LVCFMT_LEFT 			 = 0,
	LVCFMT_RIGHT			 = 1,
	LVCFMT_CENTER			 = 2,
--	LVCFMT_JUSTIFYMASK		 = 3,
--
	LVCF_FMT				 = #1,
	LVCF_WIDTH				 = #2,
	LVCF_TEXT				 = #4,
	LVCF_SUBITEM			 = #8,
--	LVCF_IMAGE				 = #10,
--	LVCF_ORDER				 = #20,
--
---- states
--	LVIS_FOCUSED			= #0001,
--	LVIS_SELECTED			= #0002,
--	LVIS_CUT				= #0004,
--	LVIS_DROPHILITED		= #0008,
--	LVIS_ACTIVATING 		= #0020,
--	LVIS_OVERLAYMASK		= #0F00,
--	LVIS_STATEIMAGEMASK 	= #F000,
--	LV_IS_CHECKED			= #2000,
--
--	LVIR_BOUNDS 			= 0,
--	LVIR_ICON				= 1,
--	LVIR_LABEL				= 2,
--	LVIR_SELECTBOUNDS		= 3,
--
--	LVHT_NOWHERE			= 1,
--	LVHT_ONITEMICON 		= 2,
--	LVHT_ONITEMLABEL		= 4,
--	LVHT_ONITEMSTATEICON	= 8,
--	LVHT_ONITEM 			= w32or_all({LVHT_ONITEMICON, LVHT_ONITEMLABEL,
--					  LVHT_ONITEMSTATEICON}),
--
--	LVHT_ABOVE				= 8,
--	LVHT_BELOW				= #10,
--	LVHT_TORIGHT			= #20,
--	LVHT_TOLEFT 			= #40,
--
--	LVSIL_NORMAL			= 0,
--	LVSIL_SMALL 			= 1,
--	LVSIL_STATE 			= 2,
--
--	LVN_BEGINDRAG = -109,
--	LVN_BEGINRDRAG = -111,
--	LVN_COLUMNCLICK = -108,
--	LVN_DELETEALLITEMS = -104,
--	LVN_DELETEITEM = -103,
--	LVN_BEGINLABELEDITW = -175,
--	LVN_ENDLABELEDITW = -176,
--	LVN_GETDISPINFOW = -177,
--	LVN_SETDISPINFOW = -178,
--	LVN_BEGINLABELEDITA = -105,
--	LVN_ENDLABELEDITA = -106,
--	LVN_GETDISPINFOA = -150,
--	LVN_SETDISPINFOA = -151,
--	LVN_INSERTITEM = -102,
	LVN_ITEMCHANGED = -101,
--	LVN_ITEMCHANGING = -100,
--	LVN_KEYDOWN = -155,
--	LVN_GETDISPINFO = -150,
--	LVN_SETDISPINFO = -151,
--	LVN_ITEMACTIVATE = -114,
--
--	LVN_FIRST				= -100,
--	LVN_LAST				= (LVN_FIRST + 99),

	SS_BITMAP =  #E,
	SS_BLACKFRAME = 7,
	SS_BLACKRECT = 4,
	SS_CENTER = 1,
	SS_CENTERIMAGE = 512,
	SS_ENHMETAFILE =  #F,
	SS_ETCHEDFRAME =  #12,
	SS_ETCHEDHORZ = 16,
	SS_ETCHEDVERT =  #11,
	SS_GRAYFRAME = 8,
	SS_GRAYRECT = 5,
	SS_ICON = 3,
	SS_LEFT = 0,
	SS_LEFTNOWORDWRAP =  #C,
	SS_NOPREFIX = 128,
	SS_NOTIFY = 256,
	SS_OWNERDRAW =  #D,
	SS_REALSIZEIMAGE =  #800,
	SS_RIGHT = 2,
	SS_RIGHTJUST =  #400,
	SS_SIMPLE = 11,
	SS_SUNKEN = 4096,
	SS_WHITEFRAME = 9,
	SS_WHITERECT = 6,
	SS_USERITEM = 10,

	DS_3DLOOK = 4,
	DS_ABSALIGN = 1,
	DS_CENTER =  #800,
	DS_CENTERMOUSE = 4096,
	DS_CONTEXTHELP =  #2000,
	DS_CONTROL =  #400,
	DS_FIXEDSYS = 8,
	DS_LOCALEDIT = 32,
	DS_MODALFRAME = 128,
	DS_NOFAILCREATE = 16,
	DS_NOIDLEMSG = 256,
	DS_SETFONT = 64,
	DS_SETFOREGROUND = 512,
	DS_SYSMODAL = 2,


---------------------
-- DrawEdge CONSTANTS
---------------------
	BDR_RAISEDINNER = 4,
	BDR_SUNKENINNER = 8,
	BDR_RAISEDOUTER = 1,
	BDR_SUNKENOUTER = 2,
	EDGE_BUMP = 9,
	EDGE_ETCHED = 6,
	EDGE_RAISED = 5,
	EDGE_SUNKEN = 10,
	BF_ADJUST = 8192,
	BF_BOTTOM = 8,
	BF_BOTTOMLEFT = 9,
	BF_BOTTOMRIGHT = 12,
	BF_DIAGONAL = 16,
	BF_DIAGONAL_ENDBOTTOMLEFT = 25,
	BF_DIAGONAL_ENDBOTTOMRIGHT = 28,
	BF_DIAGONAL_ENDTOPLEFT = 19,
	BF_DIAGONAL_ENDTOPRIGHT = 22,
	BF_FLAT = 16384,
	BF_LEFT = 1,
	BF_MIDDLE = 2048,
	BF_MONO = 32768,
	BF_RECT = 15,
	BF_RIGHT = 4,
	BF_SOFT = 4096,
	BF_TOP = 2,
	BF_TOPLEFT = 3,
	BF_TOPRIGHT = 6,


---------------------------
-- MENU FUNCTION PARAMETERS
---------------------------

	MF_BITMAP = 4,
	MF_CHECKED = 8,
	MF_DISABLED = 2,
	MF_ENABLED = 0,
	MF_GRAYED = 1,
	MF_MENUBARBREAK = 32,
	MF_MENUBREAK = 64,
	MF_OWNERDRAW = 256,
	MF_POPUP = 16,
	MF_SEPARATOR =  #800,
	MF_STRING = 0,
	MF_UNCHECKED = 0,
	MF_DEFAULT = 4096,
	MF_SYSMENU =  #2000,
	MF_HELP =  #4000,
	MF_END = 128,
	MF_RIGHTJUSTIFY =  #4000,
	MF_MOUSESELECT =  #8000,

	MF_BYCOMMAND = 0,
	MF_BYPOSITION =  #400,
	MF_HILITE = 128,
	MF_UNHILITE = 0,

	MFS_GRAYED      =   #00000003,
	MFS_DISABLED    =   MFS_GRAYED,
	MFS_CHECKED     =   MF_CHECKED,
	MFS_HILITE      =   MF_HILITE,
	MFS_ENABLED     =   MF_ENABLED,
	MFS_UNCHECKED   =   MF_UNCHECKED,
	MFS_UNHILITE    =   MF_UNHILITE,
	MFS_DEFAULT     =   MF_DEFAULT,

	MFT_STRING        = MF_STRING,
	MFT_BITMAP        = MF_BITMAP,
	MFT_MENUBARBREAK  = MF_MENUBARBREAK,
	MFT_MENUBREAK     = MF_MENUBREAK,
	MFT_OWNERDRAW     = MF_OWNERDRAW,
	MFT_RADIOCHECK    = #00000200,
	MFT_SEPARATOR     = MF_SEPARATOR,
	MFT_RIGHTORDER    = #00002000,
	MFT_RIGHTJUSTIFY  = MF_RIGHTJUSTIFY,

-- trackPopupMenu constants
	TPM_LEFTBUTTON		= #00000000,
	TPM_RIGHTBUTTON	= #00000002,

	TPM_LEFTALIGN		= #00000000,
	TPM_CENTERALIGN	= #00000004,
	TPM_RIGHTALIGN		= #00000008,



--------------
-- SCROLL BARS	
--------------
	-- style
	SBS_BOTTOMALIGN = 4,
	SBS_HORZ = 0,
	SBS_VERT = 1,
	SBS_LEFTALIGN = 2,
	SBS_RIGHTALIGN = 4,
	SBS_SIZEBOX = 8,
	SBS_SIZEBOXBOTTOMRIGHTALIGN = 4,
	SBS_SIZEBOXTOPLEFTALIGN = 2,
	SBS_SIZEGRIP = 16,
	SBS_TOPALIGN = 2,
	-- sort
	SB_HORZ = 0,
	SB_VERT = 1,
	SB_CTL = 2,
	SB_BOTH = 3,
	-- scroll notifications
	SB_LINEUP = 0,
	SB_LINELEFT = 0,
	SB_LINEDOWN = 1,
	SB_LINERIGHT = 1,
	SB_PAGEUP = 2,
	SB_PAGELEFT = 2,
	SB_PAGEDOWN = 3,
	SB_PAGERIGHT = 3,
	SB_THUMBPOSITION = 4,
	SB_THUMBTRACK = 5,
	SB_TOP = 6,
	SB_LEFT = 6,
	SB_BOTTOM = 7,
	SB_RIGHT = 7,
	SB_ENDSCROLL = 8,
	-- scroll info flags
	SIF_RANGE = #1,
	SIF_PAGE = #2,
	SIF_POS = #4,
	SIF_DISABLENOSCROLL = #8,
	SIF_TRACKPOS = #10,

	SIF_ALL = or_all( {SIF_RANGE,SIF_PAGE,SIF_POS, SIF_TRACKPOS} ),
	
	-- scroll bar messages
	SBM_ENABLE_ARROWS = 228,
	SBM_GETPOS = 225,
	SBM_GETRANGE = 227,
	SBM_GETSCROLLINFO = 234,
	SBM_SETPOS = 224,
	SBM_SETRANGE = 226,
	SBM_SETRANGEREDRAW = 230,
	SBM_SETSCROLLINFO = 233,

	
------------
-- TRACKBARS
------------
	-- styles
	TBS_HORZ            = 0,
	TBS_VERT            = 2,
	TBS_AUTOTICKS       = 1,
	TBS_NOTICKS         = 16,
	TBS_TOP             = 4,
	TBS_BOTTOM          = 0,
	TBS_LEFT            = 4,
	TBS_RIGHT           = 0,
	TBS_BOTH            = 8,
	TBS_ENABLESELRANGE  = 32,
	TBS_FIXEDLENGTH     = 64,
	TBS_NOTHUMB         = 128,
	-- notifications
	TB_BOTTOM           = 7,
	TB_ENDTRACK         = 8,
	TB_LINEDOWN         = 1,
	TB_LINEUP           = 0,
	TB_PAGEDOWN         = 3,
	TB_PAGEUP           = 2,
	TB_THUMBPOSITION    = 4,
	TB_THUMBTRACK       = 5,
	TB_TOP              = 6,
	-- messages
	TBM_CLEARSEL        = 1043,
	TBM_CLEARTICS       = 1033,
	TBM_GETCHANNELRECT  = 1050,
	TBM_GETLINESIZE     = 1048,
	TBM_GETNUMTICS      = 1040,
	TBM_GETPAGESIZE     = 1046,
	TBM_GETPOS          = 1024,
	TBM_GETPTICS        = 1038,
	TBM_GETRANGEMAX     = 1026,
	TBM_GETRANGEMIN     = 1025,
	TBM_GETSELEND       = 1042,
	TBM_GETSELSTART     = 1041,
	TBM_GETTHUMBLENGTH  = 1052,
	TBM_GETTHUMBRECT    = 1049,
	TBM_GETTIC          = 1027,
	TBM_GETTICPOS       = 1039,
	TBM_SETLINESIZE     = 1047,
	TBM_SETPAGESIZE     = 1045,
	TBM_SETPOS          = 1029,
	TBM_SETRANGE        = 1030,
	TBM_SETRANGEMAX     = 1032,
	TBM_SETRANGEMIN     = 1031,
	TBM_SETSEL          = 1034,
	TBM_SETSELEND       = 1036,
	TBM_SETSELSTART     = 1035,
	TBM_SETTHUMBLENGTH  = 1051,
	TBM_SETTIC          = 1028,
	TBM_SETTICFREQ      = 1044,


----------------
-- PROGRESS BAR
----------------
	-- progress bar styles
	PBS_SMOOTH          = 1,
	PBS_VERTICAL        = 4,
	-- progress bar messages
	PBM_SETRANGE    = WM_USER + 1,      -- set min/max
	PBM_SETPOS      = WM_USER + 2,      -- set position
	PBM_DELTAPOS    = WM_USER + 3,      -- change by requested increment
	PBM_SETSTEP     = WM_USER + 4,      -- set step size
	PBM_STEPIT      = WM_USER + 5,      -- step ahead by 1 step
	PBM_SETRANGE32  = WM_USER + 6,      -- range is double length word
	PBM_GETRANGE    = WM_USER + 7,      -- get range
	PBM_GETPOS      = WM_USER + 8,      -- get position


-------------
-- STATUS BAR
-------------
	-- style
	SBARS_SIZEGRIP = 256,

	SBT_OWNERDRAW           = #1000,
	SBT_NOBORDERS           = #0100,
	SBT_POPOUT              = #0200,
	SBT_RTLREADING          = #0400,
	SBT_TOOLTIPS            = #0800,
	-- messages
	SB_GETBORDERS           = 1031,
	SB_GETPARTS             = 1030,
	SB_GETRECT              = 1034,
	SB_GETTEXTW             = 1037,
	SB_GETTEXTLENGTHW       = 1036,
	SB_SETTEXTW             = 1035,
	SB_GETTEXTA             = 1026,
	SB_GETTEXTLENGTHA       = 1027,
	SB_SETTEXTA             = 1025,
	SB_GETTEXT              = SB_GETTEXTA,
	SB_GETTEXTLENGTH        = SB_GETTEXTLENGTHA,
	SB_SETTEXT              = SB_SETTEXTA,
	SB_SETMINHEIGHT         = 1032,
	SB_SETPARTS             = 1028,
	SB_SIMPLE               = 1033,
	SB_SETTIPTEXT           = WM_USER + 16,


----------
-- BUTTONS
----------
	-- Button Styles
	BS_3STATE = 5,
	BS_AUTO3STATE = 6,
	BS_AUTOCHECKBOX = 3,
	BS_AUTORADIOBUTTON = 9,
	BS_BITMAP = 128,
	BS_BOTTOM =  #800,
	BS_CENTER =  #300,
	BS_CHECKBOX = 2,
	BS_DEFPUSHBUTTON = 1,
	BS_GROUPBOX = 7,
	BS_ICON = 64,
	BS_LEFT = 256,
	BS_LEFTTEXT = 32,
	BS_MULTILINE =  #2000,
	BS_NOTIFY =  #4000,
	BS_OWNERDRAW =  #B,
	BS_PUSHBUTTON = 0,
	BS_PUSHLIKE = 4096,
	BS_RADIOBUTTON = 4,
	BS_RIGHT = 512,
	BS_RIGHTBUTTON = 32,
	BS_TEXT = 0,
	BS_TOP =  #400,
	BS_USERBUTTON = 8,
	BS_VCENTER =  #C00,
	BS_FLAT =  #8000,
	-- messages	
	BM_CLICK = 245,
	BM_GETCHECK = 240,
	BM_GETIMAGE = 246,
	BM_GETSTATE = 242,
	BM_SETCHECK = 241,
	BM_SETIMAGE = 247,
	BM_SETSTATE = 243,
	BM_SETSTYLE = 244,
	-- notifications
	BN_CLICKED = 0,
	BN_DBLCLK = 5,
	BN_DISABLE = 4,
	BN_DOUBLECLICKED = 5,
	BN_HILITE = 2,
	BN_KILLFOCUS = 7,
	BN_PAINT = 1,
	BN_PUSHED = 2,
	BN_SETFOCUS = 6,
	BN_UNHILITE = 3,
	BN_UNPUSHED = 3,
	-- states
	BST_CHECKED = 1,
	BST_INDETERMINATE = 2,
	BST_UNCHECKED = 0,
	BST_FOCUS = 8,
	BST_PUSHED = 4,


----------------
-- EDIT CONTROLS
----------------

	-- edit messages
	EM_CANPASTE = 1074,
	EM_CANUNDO = 198,
	EM_CHARFROMPOS = 215,
	EM_DISPLAYBAND = 1075,
	EM_EMPTYUNDOBUFFER = 205,
	EM_EXGETSEL = 1076,
	EM_EXLIMITTEXT = 1077,
	EM_EXLINEFROMCHAR = 1078,
	EM_EXSETSEL = 1079,
	EM_FINDTEXT = 1080,
	EM_FINDTEXTEX = 1103,
	EM_FINDWORDBREAK = 1100,
	EM_FMTLINES = 200,
	EM_FORMATRANGE = 1081,
	EM_GETCHARFORMAT = 1082,
	EM_GETEVENTMASK = 1083,
	EM_GETFIRSTVISIBLELINE = 206,
	EM_GETHANDLE = 189,
	EM_GETLIMITTEXT = 213,
	EM_GETLINE = 196,
	EM_GETLINECOUNT = 186,
	EM_GETMARGINS = 212,
	EM_GETMODIFY = 184,
	EM_GETIMECOLOR = 1129,
	EM_GETIMEOPTIONS = 1131,
	EM_GETOPTIONS = 1102,
	EM_GETOLEINTERFACE = 1084,
	EM_GETPARAFORMAT = 1085,
	EM_GETPASSWORDCHAR = 210,
	EM_GETPUNCTUATION = 1125,
	EM_GETRECT = 178,
	EM_GETSEL = 176,
	EM_GETSELTEXT = 1086,
	EM_GETTEXTRANGE = 1099,
	EM_GETTHUMB = 190,
	EM_GETWORDBREAKPROC = 209,
	EM_GETWORDBREAKPROCEX = 1104,
	EM_GETWORDWRAPMODE = 1127,
	EM_HIDESELECTION = 1087,
	EM_LIMITTEXT = 197,
	EM_LINEFROMCHAR = 201,
	EM_LINEINDEX = 187,
	EM_LINELENGTH = 193,
	EM_LINESCROLL = 182,
	EM_PASTESPECIAL = 1088,
	EM_POSFROMCHAR = 214,
	EM_REPLACESEL = 194,
	EM_REQUESTRESIZE = 1089,
	EM_SCROLL = 181,
	EM_SCROLLCARET = 183,
	EM_SELECTIONTYPE = 1090,
	EM_SETBKGNDCOLOR = 1091,
	EM_SETCHARFORMAT = 1092,
	EM_SETEVENTMASK = 1093,
	EM_SETHANDLE = 188,
	EM_SETIMECOLOR = 1128,
	EM_SETIMEOPTIONS = 1130,
	EM_SETLIMITTEXT = 197,
	EM_SETMARGINS = 211,
	EM_SETMODIFY = 185,
	EM_SETOLECALLBACK = 1094,
	EM_SETOPTIONS = 1101,
	EM_SETPARAFORMAT = 1095,
	EM_SETPASSWORDCHAR = 204,
	EM_SETPUNCTUATION = 1124,
	EM_SETREADONLY = 207,
	EM_SETRECT = 179,
	EM_SETRECTNP = 180,
	EM_SETSEL = 177,
	EM_SETTABSTOPS = 203,
	EM_SETTARGETDEVICE = 1096,
	EM_SETWORDBREAKPROC = 208,
	EM_SETWORDBREAKPROCEX = 1105,
	EM_SETWORDWRAPMODE = 1126,
	EM_STREAMIN = 1097,
	EM_STREAMOUT = 1098,
	EM_UNDO = 199,
	-- notifications
	EN_CHANGE = 768,
	EN_CORRECTTEXT = 1797,
	EN_DROPFILES = 1795,
	EN_ERRSPACE = 1280,
	EN_HSCROLL = 1537,
	EN_IMECHANGE = 1799,
	EN_KILLFOCUS = 512,
	EN_MAXTEXT = 1281,
	EN_MSGFILTER = 1792,
	EN_OLEOPFAILED = 1801,
	EN_PROTECTED = 1796,
	EN_REQUESTRESIZE = 1793,
	EN_SAVECLIPBOARD = 1800,
	EN_SELCHANGE = 1794,
	EN_SETFOCUS = 256,
	EN_STOPNOUNDO = 1798,
	EN_UPDATE = 1024,
	EN_VSCROLL = 1538,


------------
-- TOOL BARS
------------
	-- toolbar button styles
	TBSTYLE_BUTTON          = #0000,
	TBSTYLE_SEP             = #0001,
	TBSTYLE_CHECK           = #0002,
	TBSTYLE_GROUP           = #0004,
	TBSTYLE_CHECKGROUP      = or_bits(TBSTYLE_GROUP ,TBSTYLE_CHECK),
	TBSTYLE_DROPDOWN        = #0008,
	TBSTYLE_AUTOSIZE        = #0010,
	TBSTYLE_NOPREFIX        = #0020,
	-- toolbar styles  
	TBSTYLE_TOOLTIPS        = #0100,
	TBSTYLE_WRAPABLE        = #0200,
	TBSTYLE_ALTDRAG         = #0400,
	TBSTYLE_FLAT            = #0800,
	TBSTYLE_LIST            = #1000,
	TBSTYLE_CUSTOMERASE     = #2000,
	TBSTYLE_REGISTERDROP    = #4000,
	TBSTYLE_TRANSPARENT     = #8000,
	TBSTYLE_EX_DRAWDDARROWS = #0001,
	-- toolbar button states
	TBSTATE_CHECKED         = #01,
	TBSTATE_PRESSED         = #02,
	TBSTATE_ENABLED         = #04,
	TBSTATE_HIDDEN          = #08,
	TBSTATE_INDETERMINATE   = #10,
	TBSTATE_WRAP            = #20,
	TBSTATE_ELLIPSES        = #40,
	TBSTATE_MARKED          = #80,
	-- messages
	TB_ADDBITMAP = 1043,
	TB_ADDBUTTONS = 1044,
	TB_AUTOSIZE = 1057,
	TB_BUTTONCOUNT = 1048,
	TB_BUTTONSTRUCTSIZE = 1054,
	TB_CHANGEBITMAP = 1067,
	TB_CHECKBUTTON = 1026,
	TB_COMMANDTOINDEX = 1049,
	TB_CUSTOMIZE = 1051,
	TB_DELETEBUTTON = 1046,
	TB_ENABLEBUTTON = 1025,
	TB_GETBITMAP = 1068,
	TB_GETBITMAPFLAGS = 1065,
	TB_GETBUTTON = 1047,
	TB_ADDSTRINGW = 1101,
	TB_GETBUTTONTEXTW = 1099,
	TB_SAVERESTOREW = 1100,
	TB_ADDSTRINGA = 1052,
	TB_GETBUTTONTEXTA = 1069,
	TB_SAVERESTOREA = 1050,
	TB_GETITEMRECT = 1053,
	TB_GETROWS = 1064,
	TB_GETSTATE = 1042,
	TB_GETTOOLTIPS = 1059,
	TB_HIDEBUTTON = 1028,
	TB_INDETERMINATE = 1029,
	TB_INSERTBUTTON = 1045,
	TB_ISBUTTONCHECKED = 1034,
	TB_ISBUTTONENABLED = 1033,
	TB_ISBUTTONHIDDEN = 1036,
	TB_ISBUTTONINDETERMINATE = 1037,
	TB_ISBUTTONPRESSED = 1035,
	TB_PRESSBUTTON = 1027,
	TB_SETBITMAPSIZE = 1056,
	TB_SETBUTTONSIZE = 1055,
	TB_SETCMDID = 1066,
	TB_SETPARENT = 1061,
	TB_SETROWS = 1063,
	TB_SETSTATE = 1041,
	TB_SETTOOLTIPS = 1060,

---------------
-- TAB CONTROLS
---------------

	-- MESSAGES
	TCM_ADJUSTRECT = 4904,
	TCM_DELETEALLITEMS = 4873,
	TCM_DELETEITEM = 4872,
	TCM_GETCURFOCUS = 4911,
	TCM_GETCURSEL = 4875,
	TCM_GETIMAGELIST = 4866,
	TCM_GETITEMW = 4924,
	TCM_INSERTITEMW = 4926,
	TCM_SETITEMW = 4925,
	TCM_GETITEMA = 4869,
	TCM_INSERTITEMA = 4871,
	TCM_SETITEMA = 4870,
	TCM_GETITEMCOUNT = 4868,
	TCM_GETITEMRECT = 4874,
	TCM_GETROWCOUNT = 4908,
	TCM_GETTOOLTIPS = 4909,
	TCM_HITTEST = 4877,
	TCM_REMOVEIMAGE = 4906,
	TCM_SETCURFOCUS = 4912,
	TCM_SETCURSEL = 4876,
	TCM_SETIMAGELIST = 4867,
	TCM_SETITEMEXTRA = 4878,
	TCM_SETITEMSIZE = 4905,
	TCM_SETPADDING = 4907,
	TCM_SETTOOLTIPS = 4910,
	-- NOTIFICATIONS
	TCN_KEYDOWN = -550,
	TCN_SELCHANGE = -551,
	TCN_SELCHANGING = -552,
	-- STYLE
	TCS_BUTTONS = 256,
	TCS_FIXEDWIDTH = 1024,
	TCS_FOCUSNEVER = 32768,
	TCS_FOCUSONBUTTONDOWN = 4096,
	TCS_FORCEICONLEFT = 16,
	TCS_FORCELABELLEFT = 32,
	TCS_MULTILINE = 512,
	TCS_OWNERDRAWFIXED = 8192,
	TCS_RAGGEDRIGHT = 2048,
	TCS_RIGHTJUSTIFY = 0,
	TCS_SINGLELINE = 0,
	TCS_TABS = 0,
	TCS_TOOLTIPS = 16384,
--PL
	TCS_BOTTOM = 2,
--	TCS_FOCUSNEVER = #8000,
--	TCS_FLATBUTTONS = 8,
	-- TC_ITEM FLAGS
	TCIF_TEXT = 1,
	TCIF_IMAGE = 2,
	TCIF_PARAM = 8,
	TCIF_RTLREADING = 4,
	-- HIT-TEST
	TCHT_NOWHERE = 1,
	TCHT_ONITEM = 6,
	TCHT_ONITEMICON = 2,
	TCHT_ONITEMLABEL = 4,


-----------------------
-- OWNER-DRAWN CONTROLS
-----------------------
	-- Types
	ODT_BUTTON = 4,
	ODT_COMBOBOX = 3,
	ODT_LISTBOX = 2,
	ODT_LISTVIEW = 102,
	ODT_MENU = 1,
	ODT_STATIC = 5,
	ODT_TAB = 101,
	ODT_HEADER = 100,
	-- Action
	ODA_DRAWENTIRE = 1,
	ODA_SELECT = 2,
	ODA_FOCUS = 4,
	-- State
	ODS_CHECKED = 8,
	ODS_COMBOBOXEDIT = 4096,
	ODS_DEFAULT = 32,
	ODS_DISABLED = 4,
	ODS_FOCUS = 16,
	ODS_GRAYED = 2,
	ODS_SELECTED = 1
